/*  (c)2000 Franklin Electronic Publishers, Inc. Burlington, NJ.
    All rights reserved. */

#ifndef GUISYS_H
#define GUISYS_H

#ifdef	GUI_CPP
#define GLOBAL
#else
#define GLOBAL extern
#endif

typedef struct TIMER_ENTRY {
	struct TIMER_ENTRY *next, *prev;
	struct CViewable *object;
	U32 msecs, interval;
	S32 data;
} TIMER_ENTRY;

typedef struct HOLD_MESSAGE {
	MSG_TYPE type;
	struct CViewable *target;
	S32 data;
} HOLD_MESSAGE;

/* Internal functions.  These are not exported from the shared library */

struct CWindow;

void GUI_AddWindow( struct CWindow *window );
void GUI_DeleteWindow( struct CWindow *window );
void GUI_DrawAllWindows(void);
BOOL GUI_IsWindowVisible( struct CWindow *window );
void GUI_TimerLoop(void);
void GUI_TimerEnqueue( TIMER_ENTRY *ptr );



///////////////////////////////////////////////////////////////////
//                                                               //
//   Internal Variables (not visible outside the shared library) //
//                                                               //
///////////////////////////////////////////////////////////////////

GLOBAL GUIFLAGS		GUI_Flags;
GLOBAL U32		*OS_availaddr_ptr;
GLOBAL BOOL		*OS_is_foreground_ptr;
GLOBAL S32		(*GUI_main_ptr)(MSG_TYPE,struct CViewable *,S32);
GLOBAL struct CArray *GUI_Visible_Windows, *GUI_OSNotify_List;
GLOBAL void	   *GUI_Jump_Buffer;
GLOBAL const FONT *GUI_System_Font, *GUI_Default_Font;
GLOBAL void	   *GUI_AssertMemoryBlock;
GLOBAL volatile U8 GUI_TimerDisableCount;
GLOBAL volatile BOOL GUI_ThreadIsActive[2];
GLOBAL TIMER_ENTRY  GUI_TimerList;
GLOBAL BOOL	    GUI_TimerPending;
GLOBAL BOOL	    GUI_LandscapeMode;
GLOBAL GUI_ErrorHandler_TYPE GUI_ErrorHandler;
GLOBAL  const FONTGROUP *Default_Fontgroup, *System_Fontgroup;
#define GUI_NUMHOLDMSGS 16
#define GUI_HOLDEVENT   0xf5677569  /* 'gui' */
#define GUI_UPDATEEVENT 0xf5757064  /* 'upd' */

GLOBAL HOLD_MESSAGE GUI_HoldMessage[GUI_NUMHOLDMSGS];

#define SCROLLBAR_CAR_HEIGHT  7

#undef GLOBAL

#endif
